/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.liferay.notifications.model.impl;

import com.liferay.notifications.model.UserNotificationEvent;
import com.liferay.notifications.service.UserNotificationEventLocalServiceUtil;

import com.liferay.portal.kernel.exception.SystemException;

/**
 * The extended model base implementation for the UserNotificationEvent service. Represents a row in the &quot;Notifications_UserNotificationEvent&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This class exists only as a container for the default extended model level methods generated by ServiceBuilder. Helper methods and all application logic should be put in {@link UserNotificationEventImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see UserNotificationEventImpl
 * @see com.liferay.notifications.model.UserNotificationEvent
 * @generated
 */
public abstract class UserNotificationEventBaseImpl
	extends UserNotificationEventModelImpl implements UserNotificationEvent {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a user notification event model instance should use the {@link UserNotificationEvent} interface instead.
	 */

	public void persist() throws SystemException {
		if (this.isNew()) {
			UserNotificationEventLocalServiceUtil.addUserNotificationEvent(this);
		}
		else {
			UserNotificationEventLocalServiceUtil.updateUserNotificationEvent(this);
		}
	}
}